routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [\App\Http\Controllers\ArticlesController::class, 'index'])->name('dashboard');

Route::prefix('admin')->middleware(['auth', 'admin'])->name('admin.')->group(function () {
    Route::get('dashboard', [App\Http\Controllers\Admin\HomeController::class, 'index'])->name('dashboard');
    Route::get('comments', [App\Http\Controllers\Admin\CommentsController::class, 'index'])->name('comments.index');
    Route::get('comments/{comment}', [App\Http\Controllers\Admin\CommentsController::class, 'show'])->name('comments.show');
    Route::patch('comments/{comment}', [App\Http\Controllers\Admin\CommentsController::class, 'approve'])->name('comments.approve');
    Route::delete('comments/{comment}', [App\Http\Controllers\Admin\CommentsController::class, 'destroy'])->name('comments.delete');
    Route::get('users', [App\Http\Controllers\Admin\UsersController::class, 'index'])->name('users.index');
    Route::get('users/{user}', [App\Http\Controllers\Admin\UsersController::class, 'edit'])->name('users.edit');
    Route::patch('users/{user}', [App\Http\Controllers\Admin\UsersController::class, 'update'])->name('users.update');
});

Route::resource('articles', \App\Http\Controllers\ArticlesController::class)->middleware(['auth']);

Route::resource('articles.comments', \App\Http\Controllers\CommentsController::class)->only(['store', 'destroy']);

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

/**
 * @property bool approved
 * @property mixed roles
 */
class User extends Authenticatable
{
    use HasFactory, Notifiable;

    public const ADMIN = 'Admin';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * @return HasMany
     */
    public function articles(): HasMany
    {
        return $this->hasMany(Article::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class);
    }

    /**
     * @return BelongsToMany
     */
    public function roles(): BelongsToMany
    {
        return $this->belongsToMany(Role::class, 'user_role');
    }

    /**
     * @param mixed ...$roles
     * @return bool
     */
    public function hasRole(...$roles): bool
    {
        foreach ($roles as $role)
        {
            if($this->roles->contains('name', $role)) {
                return true;
            }
        }
        return false;
    }
}

app/Http/Controllers/Admin/UsersController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class UsersController extends Controller
{
    /**
     * @param Request $request
     * @return Application|Factory|View
     */
    public function index(Request $request)
    {
        $users = \App\Models\User::all();
        return view('admin.users.index', compact('users'));
    }

    /**
     * @param User $user
     * @return Application|Factory|View
     */
    public function edit(User $user)
    {
        $roles = \App\Models\Role::all();
        return view('admin.users.edit', compact('user', 'roles'));
    }

    /**
     * @param Request $request
     * @param User $user
     * @return RedirectResponse
     */
    public function update(Request $request, User $user): RedirectResponse
    {
        $user->roles()->sync($request->get('roles'));
        return redirect()->route('admin.users.index');
    }
}

resources/views/admin/users/edit.blade.php
@extends('layouts.app')

@section('content')
    <h2>User: {{$user->name}}</h2>

    <p>
    <form action="{{route('admin.users.update', compact('user'))}}" method="post">
        @csrf
        @method('patch')
        <div class="row">
            <div class="col">
                <select name="roles[]" style="width: 100%; height: 150px" class="form-select" multiple aria-label="multiple select example">
                    @foreach($roles as $role)
                        @if($user->hasRole($role->name))
                            <option value="{{$role->id}}" selected>{{$role->name}}</option>
                        @else
                            <option value="{{$role->id}}">{{$role->name}}</option>
                        @endif
                    @endforeach
                </select>
            </div>

        </div>
        <button type="submit" class="btn btn-success">Update</button>
    </form>
    </p>
@endsection

resources/views/admin/users/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col">

            <h2>Users</h2>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <table class="table table-striped">
                <thead>
                <tr>
                    <th>#</th>
                    <th>Name</th>
                    <th>Roles</th>
                    <th colspan="2">Actions</th>
                </tr>
                </thead>
                <tbody>
                @foreach($users as $user)
                    <tr>
                        <td>{{$user->id}}</td>
                        <td>
                            {{$user->name}}
                        </td>
                        <td>
                            <table class="table-bordered">
                                <tbody>
                                @foreach($user->roles as $role)
                                    <tr>
                                        <td>{{$role->name}}</td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </td>
                        <td colspan="2">
                            <a role="button" class="btn btn-sm btn-outline-primary" href="{{route('admin.users.edit', compact('user'))}}">
                                Set roles
                            </a>

                        </td>
                    </tr>
                @endforeach
                </tbody>

            </table>
        </div>
    </div>

@endsection